***********************************************************************
* Program     : BIRTHDAY.PRG 
* Written by  : Charlie Thompson, CIS 72740,346 
***********************************************************************
* Version 1.0 : 13-Sep-91 
* Version 1.1 : Changed by Jrgen Wondzinski, CIS 100015,676
*             : Support for foreign languages added
*             : PRIVATE <var1>,<var2>... changed to PRIVATE ALL
*             : Date checking changed, now without changing date format
*             : Erased all occurences of "SET DATE..."
*             : Added 2 to Window rows for better optics
*             : Killed the UPPER on mname, because we foreign users have
*             : different greetings for diffent sex... <g> So German users
*             : have to substitute "r Hans" or "Eva" for a correct greeting. 
***********************************************************************
* Version 1.11: 12/14/91 (or is it 14-Dec-91 <g>)
*             : Changed by Charlie Thompson
*             : Changed method for adding leading space to First_Syl to
*             : to avoid problem with incorrect German greeting "Liebe r"
*             : Added SET CURSOR OFF for better screen appearance
*             : Replaced "WAIT WINDOW NOWAIT" with a UDF for FoxPro 1 
*             : compatibility.  
*             : Moved ACTIVATE WINDOW for better appearance on slow systems.
***********************************************************************
PARAMETERS mname, mdate, mcolor
PRIVATE ALL

IF SET("TALK") == "ON"
   SET TALK OFF
   mtalk = "ON"
ELSE
   mtalk = "OFF"
ENDIF
mescape = SET("ESCAPE")
SET ESCAPE OFF
mcursor = SET("CURSOR")
SET CURSOR OFF
***********************************************************************
*** Did we get a Birthday ?
***********************************************************************
IF TYPE("mdate") == "D" 				&&  See if today is the birthday 
	IF RIGHT(DTOS(mdate),4) # RIGHT(DTOS(DATE()),4)
	    SET ESCAPE &mescape				&& It's not the birthday, 
	    SET TALK &mtalk					&& so restore environment  
    	RETURN .F.						&& and exit
	ENDIF
ENDIF

***********************************************************************
*** Should we use an extra Color Scheme?
***********************************************************************
mcolor = IIF(TYPE("mcolor")="N" .AND. BETWEEN(mcolor, 1, 24), mcolor, 7)


***********************************************************************
*** Insert a name in the text if given 
***********************************************************************
IF TYPE("mname") == "C" .AND. ! EMPTY(mname)
   mname = ALLTRIM(mname)+" "
   IF "-" $ mname
      first_syl = " "+SUBSTR(mname, 1, AT("-", mname) -1)
      secon_syl = TRIM(SUBSTR(mname, AT("-", mname) +1))+"!" 
   ELSE
      first_syl = " "+TRIM(mname)
      secon_syl = "!"
   ENDIF
ELSE
   first_syl = " _____"
   secon_syl = "____!"
ENDIF


***********************************************************************
*** Make a Siren ***
***********************************************************************
FOR i = 1 TO 3
	FOR f = 900 TO 1100 STEP 25
    	SET BELL TO f,1
        ?? CHR(7)
    ENDFOR
ENDFOR
WAIT WINDOW


***********************************************************************
*** Now our famous Birthday Gift
***********************************************************************
DEFINE WINDOW _yer_bday_ ;
   FROM (SROWS()/2)-4, (SCOLS()/2)-25 TO (SROWS()/2)+4, ;
      (SCOLS()/2)+25 PANEL COLOR SCHEME (mcolor) SHADOWS
***********************************************************************
*** Now play the tune 
***********************************************************************
dur = 4
DO CASE
CASE SET("DATE") = "GERMAN"
	=nowait("Heute ist doch der "+dtoc(date())+"....")
	DO CASE
	CASE First_Syl = " _____"
		First_Syl = "r Mee"
		Secon_Syl = "ensch !"
	CASE LEFT(First_Syl, 3) == " r "
		?? CHR(7)
		First_Syl = LTRIM(First_Syl)
	ENDCASE
	ACTIVATE WINDOW _yer_bday_ 
	SET BELL TO 392, dur    && G4
	? "  Al"+CHR(7)
	?? "les "+CHR(7)
	SET BELL TO 440, dur*2  && A5
	?? "Gu"+CHR(7)
	SET BELL TO 392, dur*2  && G4
	?? "te"+CHR(7)
	SET BELL TO 523, dur*2  && C5
	?? " fr"+CHR(7)
	SET BELL TO 494, dur*4  && B5
	?? " Dich..."+CHR(7)
	SET BELL TO 392, dur    && G4
	? SPACE(5)+"A"+CHR(7)
	?? "lles"+CHR(7)
	SET BELL TO 440, dur*2  && A5
	?? " Sch"+CHR(7)
	SET BELL TO 392, dur*2  && G4
	?? "ne"+CHR(7)
	SET BELL TO 587, dur*2  && D5
	?? " fr"+CHR(7)
	SET BELL TO 523, dur*4  && C5
	?? " Dich..."+CHR(7)
	SET BELL TO 392, dur    && G4
    ? SPACE(10)+"Sch"+CHR(7)
	?? "nen"+CHR(7)
	SET BELL TO 784, dur*2  && G5
	?? " Geburts"+CHR(7)
	SET BELL TO 659, dur*2  && E5
	?? "tag,"+CHR(7)
	SET BELL TO 523, dur*2  && C5
	? SPACE(15)+"Liebe"+CHR(7)
	SET BELL TO 494, dur*2  && B5
	?? first_syl+CHR(7)
	SET BELL TO 440, dur*4  && A5
	?? secon_syl+CHR(7)
	SET BELL TO 699, dur    && F5
	? SPACE(20)+"Sch"+CHR(7)
	?? "nen"+CHR(7)
	SET BELL TO 659, dur*2  && E5
	?? " Geburts"+CHR(7)
	SET BELL TO 523, dur*2  && C5
	?? "tag"+CHR(7)
	SET BELL TO 587, dur*2  && D5
	?? " fr"+CHR(7)
	SET BELL TO 523, dur*4  && C5
	?? " Dich!"+CHR(7)
	? ""
	***********************************************************************
* CASE SET("DATE") = "FRENCH"
	**** Does someone out there want to write this?
* CASE SET("DATE") = "ITALIAN"	
   **** Come on folks, let's make this a truly international effort!
* CASE SET("DATE") = "JAPAN"
	**** My _monitor_ doesn't even speak Japanese. <g>
OTHERWISE && All other languages...
	**********************************
	* Don't use "NOWAIT" if FoxPro 1
	**********************************
	=nowait("Today is YOUR day!")
	ACTIVATE WINDOW _yer_bday_ 
	SET BELL TO 392, dur  && G4
	? "  Hap"+CHR(7)
	?? "py"+CHR(7)
	SET BELL TO 440, dur*2  && A5
	?? " Birth"+CHR(7)
	SET BELL TO 392, dur*2  && G4
	?? "day"+CHR(7)
	SET BELL TO 523, dur*2  && C5
	?? " to"+CHR(7)
	SET BELL TO 494, dur*4  && B5
	?? " You..."+CHR(7)
	SET BELL TO 392, dur  && G4
	? SPACE(7)+"Hap"+CHR(7)
	?? "py"+CHR(7)
	SET BELL TO 440, dur*2  && A5
	?? " Birth"+CHR(7)
	SET BELL TO 392, dur*2  && G4
	?? "day"+CHR(7)
	SET BELL TO 587, dur*2  && D5
	?? " to"+CHR(7)
	SET BELL TO 523, dur*4  && C5
	?? " You..."+CHR(7)
	SET BELL TO 392, dur  && G4
	? SPACE(12)+"Hap"+CHR(7)
	?? "py"+CHR(7)
	SET BELL TO 784, dur*2  && G5
	?? " Birth"+CHR(7)
	SET BELL TO 659, dur*2  && E5
	?? "day,"+CHR(7)
	SET BELL TO 523, dur*2  && C5
	? SPACE(17)+"Dear"+CHR(7)
	SET BELL TO 494, dur*2  && B5
	?? first_syl+CHR(7)
	SET BELL TO 440, dur*4  && A5
	?? secon_syl+CHR(7)
	SET BELL TO 699, dur  && F5
	? SPACE(22)+"Hap"+CHR(7)
	?? "py"+CHR(7)
	SET BELL TO 659, dur*2  && E5
	?? " Birth"+CHR(7)
	SET BELL TO 523, dur*2  && C5
	?? "day"+CHR(7)
	SET BELL TO 587, dur*2  && D5
	?? " to"+CHR(7)
	SET BELL TO 523, dur*4  && C5
	?? " You!"+CHR(7)
	? ""
ENDCASE
=NOWAIT()
***********************************************************************
*** Restore the environment 
***********************************************************************
CLEAR TYPEAHEAD
SET CURSOR OFF
WAIT WINDOW 
SET CURSOR ON
RELEASE WINDOW _yer_bday_
SET BELL TO
SET ESCAPE &mescape
SET TALK &mtalk
SET CURSOR &mcursor
RETURN .T.

FUNCTION nowait
PARAMETERS string
PRIVATE ALL
IF TYPE("string") = "L"
	IF WEXIST("_no_wait_")
		RELEASE WINDOW _no_wait_
	ENDIF
	RETURN ""
ENDIF
was_output = WOUTPUT()
string = LEFT(string, SCOLS()-8)
DEFINE WINDOW _no_wait_ ;
	FROM 1, SCOLS()-7-LEN(string) TO 3, SCOLS()-4;
	COLOR SCHEME 5 SHADOWS
ACTIVATE WINDOW _no_wait_
?? " "+string
IF EMPTY(was_output)
	ACTIVATE SCREEN
ELSE
	ACTIVATE WINDOW &was_output
ENDIF
RETURN ""