****************************************************************************
* Program:  rest.prg
*        :  (c) 1991 Charlie Thompson - CompuServe ID:  72740,346
*        :
* Purpose:  A kludge to provide rests and phrasing in FoxPro SET BELL tunes
*  Syntax:  = rest(<ExpN>)
*        :     <ExpN> = the pause duration in <ExpN>/19ths of a second - the
*        :        method used by SET BELL's duration parameter
* Returns:  nothing (null string)
*   Notes:  The code below should be placed in the file of any tune which
*        :  uses it, to prevent a disk access lag for the 1st rest.  This
*        :  function should be used sparingly, since it's not possible to
*        :  truly syncronize INKEY()'s timing with SET BELL's.  Time lags
*        :  around 4% while a "rest" is executing.  This is very noticeable
*        :  at faster tempos, especially when combined with repetative
*        :  patterns.  The musical effect is acceptable however with slower
*        :  tempos, long rests, or to occasionally break up legato phrasing.
****************************************************************************
FUNCTION rest
PARAMETERS dur
CLEAR TYPEAHEAD
= INKEY(dur/19, "H")
RETURN ""
